<?php

namespace App\Services;

use App\Models\EmailTemplate;
use Illuminate\Support\Facades\Mail;

class EmailService
{
    // public function sendEmail($templateId, $to, $data = [])
    // {
    //     $template = EmailTemplate::findOrFail($templateId);
    //     $content = $this->replaceVariables($template->content, $data);

    //     Mail::send([], [], function ($message) use ($to, $template, $content) {
    //         $message->to($to)
    //             ->subject($template->name)
    //             ->setBody($content, 'text/html');
    //     });
    // }
    public function sendEmail($templateId, $to, $data = [])
    {
        $template = EmailTemplate::findOrFail($templateId);
        $content = $this->replaceVariables($template->content, $data);

        Mail::send([], [], function ($message) use ($to, $template, $content, $data) {
            $message->to($to)
                ->subject($data['subject'] ?? $template->subject)
                ->setBody($content, 'text/html');

            // Set sender name and address
            $senderName = $data['sender_name'] ?? $template->sender_name;
            $senderAddress = $data['sender_address'] ?? $template->sender_address;

            if ($senderName && $senderAddress) {
                $message->from($senderAddress, $senderName);
            }
        });
    }

    private function replaceVariables($content, $data)
    {
        foreach ($data as $key => $value) {
            $content = str_replace("{{ $key }}", $value, $content);
        }

        return $content;
    }
}
