<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\NewCourse;

class CourseController extends Controller
{
    public function assignCourse(Request $request, $userId, $courseId)
    {
        $user = User::find($userId);
        $course = NewCourse::find($courseId);

        if (!$user || !$course) {
            return response()->json(['message' => 'User or course not found'], 404);
        }

        $user->courses()->attach($course);

        return response()->json(['message' => 'Course assigned successfully']);
    }

    public function getAssignedCourses($userId)
    {
        $user = User::find($userId);

        if (!$user) {
            return response()->json(['message' => 'User not found'], 404);
        }

        $assignedCourses = $user->courses;

        return response()->json(['assignedCourses' => $assignedCourses]);
    }
}
