<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\EmailTracking;
use Illuminate\Support\Facades\Auth;
use App\Models\EmailSentTrack;
class EmailTrackingController extends Controller
{

public function emailTrackCount(){

    $emailtrackcount = EmailTracking::count();
    $clickcount = EmailTracking::where('event_type','click')->count();
    $opencount = EmailTracking::where('event_type','open')->count();

    // $emailtrackcount = EmailTracking::distinct('user_id', 'template_id')->count();
    // $clickcount = EmailTracking::where('event_type', 'click')->distinct('user_id', 'template_id','event_type')->count('user_id');
    // $opencount = EmailTracking::where('event_type', 'open')
    // ->distinct('user_id', 'template_id')
    // ->count('user_id');

    return response()->json(['message'=>'Email Track Counts', 'emailtrackcounts'=>$emailtrackcount,'click'=>$clickcount,'open'=>$opencount],200);
}

    public function trackOpen($templateId, $email,$userId,$url)
    {
        $this->logEvent('open', $templateId, $email,$userId,$url);
        return response()->make(file_get_contents(public_path('images/stlogo.png')), 200, ['Content-Type' => 'image/png']);
    }

    // public function trackClick(request $request)
    // {
    //    $templateId =  $request->input('templateId');
    //     $email =      $request->input('email');
    //    $userId =  $request->input('userid');
    //    $url =  $request->input('url');
    //     $this->logEvent('click', $templateId, $email,$userId,$url);
        
    //     return response()->json(['message'=> 'recorded']);
    // }

// public function trackClick(Request $request)
//     {
//         // Validate request parameters
//         $validatedData = $request->validate([
//             'templateId' => 'required',
//             'email' => 'required|email',
//             'userId' => 'required|integer',
//             'url' => 'url',
//         ]);

//         // Extract validated data
//         $templateId = $validatedData['templateId'];
//         // $templateId = intval($validatedData['templateId']);
//         $email = $validatedData['email'];
//         $userId = $validatedData['userId'];
//         $url = $validatedData['url'];

//         // Log the click event
//         $this->logEvent('click', $templateId, $email, $userId, $url);

//         return response()->json(['message' => 'Click event recorded successfully']);
//     }

public function trackClick(Request $request)
{
    // Validate request parameters
    $validatedData = $request->validate([
        'templateId' => 'required|integer',
        'email' => 'required|email',
        'userId' => 'required|integer',
        'url' => 'url',
    ]);

    // Extract validated data
    $templateId = $validatedData['templateId'];
    $email = $validatedData['email'];
    $userId = $validatedData['userId'];
    $url = $validatedData['url'];

    // Log the received data for debugging
    \Log::info('Received Click Event Data:', [
        'templateId' => $templateId,
        'email' => $email,
        'userId' => $userId,
        'url' => $url,
    ]);

    try {
        // Check if the click event already exists in the database
        // $existingEvent = EmailTracking::where('template_id', $templateId)
        //     ->where('user_id', $userId)
        //     ->first();

        // if ($existingEvent) {
        //     return response()->json(['message' => 'Already saved in database']);
        // }

        // Log the click event
        $this->logEvent('click', $templateId, $email, $userId, $url);

        return response()->json(['message' => 'Click event recorded successfully']);
    } catch (\Exception $e) {
        // Log any exceptions that occur
        \Log::error('Error recording click event:', ['exception' => $e]);
        return response()->json(['error' =>  $e .'Failed to record click event'], 500);
    }
}


    private function logEvent($eventType, $templateId, $email,$userId,$url)
    {
        
        EmailTracking::create([
            'event_type' => $eventType,
            'email' => $email,
            'recipient' => $email,
            'template_id' => $templateId,
            'user_id' => $userId,
            'url'=>$url,
        ]);
    }


// public function getTrackingEvents()
// {
//     try {
//         $admin = Auth::user();
//         $query = EmailTracking::where('admin_id', $admin->id);

//         $totalclicks =  $query->where('event_type', 'click')->count();
//         $totalopens =  $query->where('event_type', 'open')->count();
//         $totalemails = $query->count();

//         return response()->json(['total' => $totalemails, 'total_clicks' => $totalclicks, 'total_opens' => $totalopens], 200);
//     } catch (\Exception $e) {
//         return response()->json(['error' => 'Error fetching tracking events', 'message' => $e->getMessage()], 500);
//     }
// }

public function getTrackingEvents()
{
    try {
        $admin = Auth::user();

        // Retrieve all template IDs associated with the admin from the email_sent_tracks table
        $templateIds = EmailSentTrack::where('admin_id', $admin->id)->pluck('template_id');

        // Query tracking events from the email_tracking table based on template IDs
        $trackingEvents = EmailTracking::whereIn('template_id', $templateIds) ->distinct(['user_id', 'template_id'])->get();

        // Count the total number of clicks and opens
        $totalClicks = $trackingEvents->where('event_type', 'click')->count();
        // $totalOpens = $trackingEvents->where('event_type', 'open')->count();
        $totalOpens = $trackingEvents->where('event_type', 'open')
                             ->unique('event_type')
                             ->count();
        $totalEmails = $templateIds->count();



        return response()->json([
            'total' => $totalEmails,
            'total_clicks' => $totalClicks,
            'total_opens' => $totalOpens
        ], 200);
    } catch (\Exception $e) {
        return response()->json([
            'error' => 'Error fetching tracking events',
            'message' => $e->getMessage()
        ], 500);
    }
}





        public function getReport($eventType, $userId, $templateId)
    {
        try {
            $total = EmailTracking::where('user_id',$userId)->count();
            $query = EmailTracking::where('event_type', $eventType)
                ->where('user_id', $userId)
                ->where('template_id', $templateId);

            $events = $query->with('template')->get();
            $eventCount = $events->count();
        if ($eventCount === 0) {
            return response()->json(['message' => 'No ' .  $eventType .'ed'. ' on activity to report for this employee!'], 404);
        }
            return response()->json(['events' => $events, 'event_count' => $eventCount, 'total_count'=>$total], 200);
        } catch (\Illuminate\Database\QueryException $e) {
            return response()->json(['error' => 'Error executing database query', 'message' => $e->getMessage()], 500);
        } catch (\Exception $e) {
            return response()->json(['error' => 'Unexpected error', 'message' => $e->getMessage()], 500);
        }
    }
}
