<?php
namespace App\Http\Controllers\Api;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Http\Requests\StoreUserRequest;
use App\Http\Requests\UpdateUserRequest;
use App\Http\Resources\UserResource;
use App\Models\User;
use App\Models\NewCourse;
use App\Models\Task;
use App\Models\AccountAdmin;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Mail;
use App\Mail\CourseAssigningMail;
use App\Mail\MailtoNotStartedUser;
use App\Mail\MailtoNotStartedCourse;
use App\Helpers\AdminHelper;
use Illuminate\Support\Facades\Log;
use App\Http\Requests\LoginRequest;
use Illuminate\Validation\Rules\Password;
use Illuminate\Validation\ValidationException;



class UserController extends Controller

{
   public function index()
        {
            $admin = Auth::user();

            $assignedId = AdminHelper::getAssignedId();

            // Determine the admin ID based on the value of assignedId
            $adminId = ($assignedId === "null") ? $admin->id : $assignedId; 
            
            // $accountadmins = $admin->accountadmins()->get();
            //         // dd($accountadmins);

            // // Initialize $userIds as an array with the admin's ID as its first element.
            // $userIds = [$admin->id];
 

            // if (!empty($accountadmins)) {
            //     if (isset($accountadmins[0]) && $accountadmins[0]->account_ids) {
            //         // Check if account_ids is an array or a single integer
            //         if (is_array($accountadmins[0]->account_ids)) {
            //             // Merge the array of account IDs into the $userIds array
            //             $userIds = array_merge($userIds, $accountadmins[0]->account_ids);
            //             // dd($userIds);
            //         } else {
            //             // If it's a single ID, just add it to the $userIds array
            //             $userIds[] = $accountadmins[0]->account_ids;
            //         }
            //     }
            // }

            if ($admin->role !== 1 && $admin->role !== 2) {
                return response()->json(['message' => 'Unauthorized. Only admins can view users.'], 403);
            }
            // dd($userIds);

            // Now use $userIds as an array in the query.
            $users = User::where('admin_id', $adminId)->orderByDesc('created_at')->get();

            return UserResource::collection($users);
        }





    public function showAdmin()
    {

    $users = User::where('role', 1)->orderByDesc('id')->get();

    return UserResource::collection($users);
    }

    public function editAdmin($adminId)
    {
    
        $admin = User::where('role', 1)->find($adminId);
    
        if (!$admin) {
            return response()->json(['error' => 'Admin not found'], 404);
        }
    
        return new UserResource($admin);
    }

    
    
    public function userCount()
    {

        $admin = Auth::user();

            $assignedId = AdminHelper::getAssignedId();

            // Determine the admin ID based on the value of assignedId
            $adminId = ($assignedId === "null") ? $admin->id : $assignedId;

        if ($admin->role !== 1 && $admin->role !== 2) {
            return response()->json(['message' => 'Unauthorized. Only admins can view user count.'], 403);
        }

        $userCount = User::where('admin_id', $adminId)->count();
        // $accountadmins = $admin->accountadmins()->distinct()->pluck('account_ids')->toArray();
        // if(isset($accountadmins)){
        //     foreach ($accountadmins as $accountadmin){
        //         $adminAccount = User::find($accountadmin);
        //         if($adminAccount){
        //             $userCount += User::where('admin_id', $adminAccount->id)->count();
        //         }
        //     }
        // }
       
    
        return response()->json(['user_count' => $userCount]);
    }
    
    //    public function FilterByName(Request $request){
    //     $searchTerm = $request->input('name');
    
    //     // Validate if search term has at least 2 characters
    //     if(strlen($searchTerm) < 2) {
    //         return response()->json(['error' => 'Search term must be at least 2 characters.'], 400);
    //     }
    
    //     $users = User::where('name', 'like', '%' . $searchTerm . '%')->where("role", "0")->get();
    
    //     return response()->json(['users' => $users], 200);
    // }

    public function FilterByName(Request $request)
    { 
        // $user = Auth::user();
        // $admin_id = $user->id;

        // $searchTerm = $request->input('name');
    
        // // Validate if search term has at least 2 characters
        // if(strlen($searchTerm) < 2) {
        //     return response()->json(['error' => 'Search term must be at least 2 characters.'], 400);
        // }
        // $users = User::where('name', 'like', '%' . $searchTerm . '%')
        // ->where('role', '0')
        // ->where('admin_id', $admin_id)
        // ->get();

        // $admin = Auth::user();
        // $accountadmins = $admin->accountadmins()->distinct()->pluck('account_ids')->toArray();

        // if ($accountadmins) {
        //     foreach ($accountadmins as $accountadmin) {
        //         $adminAccount = User::find($accountadmin);
        //         if ($adminAccount) {
        //             $users = $users->merge(
        //                 User::where('name', 'like', '%' . $searchTerm . '%') ->where('role', '0') ->where('admin_id', $adminAccount->id) ->get()
        //             );
        //         }
        //     }
        // }
        // return response()->json(['users' => $users], 200);

        $admin = Auth::user(); 
            $AdminSwitchId=$request->input('AdminSwitchId');

            $admin_id = ($AdminSwitchId === "null") ? $admin->id : $AdminSwitchId;  
            $searchTerm = $request->input('name');
    
        // Validate if search term has at least 2 characters
        if(strlen($searchTerm) < 2) {
            return response()->json(['error' => 'Search term must be at least 2 characters.'], 400);
        }
        $users = User::where('name', 'like', '%' . $searchTerm . '%')
        ->where('role', '0')
        ->where('admin_id', $admin_id)
        ->get();
         
        $admin=[$admin_id]; 
        $accountadmins = $admin;
 
        if ($accountadmins) {
            foreach ($accountadmins as $accountadmin) {
                $adminAccount = User::find($accountadmin);
                if ($adminAccount) {
                    $users = $users->merge(
                        User::where('name', 'like', '%' . $searchTerm . '%') ->where('role', '0') ->where('admin_id', $adminAccount->id) ->get()
                    );
                }
            }
        }
    
        return response()->json(['users' => $users], 200);

    }

    public function adminCount()
    {

        $admins = User::where('role', 1)->get();
        $adminCount = count($admins);
        return response()->json(['admin_count' => $adminCount]);
    }


    public function taskcount()
    {
      
        $admin = Auth::user();

        if (
            $admin->role !== 1 && $admin->role !== 2) {
            return response()->json(['message' => 'Unauthorized. Only admins can view task count.'], 403);
        }
        if($admin->role === 1){
            // Retrieve the users who have been assigned courses by the admin
        $assignedUsers = User::whereHas('courses', function ($query) use ($admin) {
            $query->where('admin_id', $admin->id);
        })->get();

        // Calculate the task count
        $taskcount = $assignedUsers->count();
        }
        else{
            $assignedCourses = User::whereHas('courses')->with('courses')->get();
        $taskcount = count($assignedCourses);
        }

        // Return a JSON response with the task count
        return response()->json(['task_count' => $taskcount]);
    }

    // public function store(StoreUserRequest $request)
    public function store(Request $request)
    {   
            // Custom error messages
            $messages = [
                'name.required' => 'The name field is required.',
                'name.max' => 'The name must not exceed 55 characters.',
                'email.required' => 'An email address is required.',
                'email.email' => 'The email format is invalid.',
                'email.unique' => 'This email is already registered. Please use a different email.',
                'company_name.max' => 'The company name must not exceed 255 characters.',
                'member.max' => 'The member field must not exceed 255 characters.',
                'password.required' => 'A password is required.',
                'password.min' => 'The password must be at least 8 characters long.',
                'password.letters' => 'The password must contain at least one letter.',
                'password.symbols' => 'The password must contain at least one special character.',
            ];
        
            try {
                // Validate the request with the custom messages
                $data=$request->validate([
                    'name' => 'required|string|max:55',
                    'email' => 'required|email|unique:users,email',
                    'company_name' => 'string|max:255',
                    'member' => 'max:255|string',
                    'password' => [
                        'required',
                        Password::min(8)
                            ->letters()
                            ->symbols(),
                    ],
                ], $messages);
        
                // Logic to handle valid data...
        
            } catch (ValidationException $e) {
                $firstErrorMessage = collect($e->errors())->flatten()->first();
                return response()->json([
                    'message' => $firstErrorMessage,
                    'errors' => $e->errors(),
                ], 422);
            }

        // $data = $request->validated();
        // dd($data);
        
        $admin = Auth::user();

        if (
            $admin->role !== 1 && $admin->role !== 2
        ) {
            return response()->json(['message' => 'Unauthorized. Only admins can create users.'], 403);
        }

        $assignedId = AdminHelper::getAssignedIdByPost($request);

        $adminId = ($assignedId === "null") ? $admin->id : $assignedId;  


        $data['admin_id'] = $adminId;

        $data['password'] = bcrypt($data['password']);

        //   $accountadmins = $admin->accountadmins()->distinct()->pluck('account_ids')->toArray();
          $accountadmins = [$adminId];
          if($accountadmins){
             foreach ($accountadmins as $accountadmin){
                $adminAccount = User::find($accountadmin);
                if($adminAccount){
                   $data['admin_id'] = $adminAccount->id;
                }
             }
          }
          // dd($data);

        $user = User::create($data);
        
        $adminLogo = $admin->logo;
        if ($adminLogo) {
            $user->logo()->create(['logo_path' => $adminLogo->logo_path]);
        }
        return response(new UserResource($user), 201);
    }
  
    public function show(User $user)
    {
        return new UserResource($user);
    }

    // public function update(UpdateUserRequest $request, User $user)
    public function update(Request $request, User $user)
    {
        
            // Custom error messages
            $messages = [
                'name.required' => 'The name field is required.',
                'name.max' => 'The name must not exceed 55 characters.',
                'email.required' => 'An email address is required.',
                'email.email' => 'The email format is invalid.',
                'email.unique' => 'This email is already registered. Please use a different email.',
                'company_name.max' => 'The company name must not exceed 255 characters.',
                'member.max' => 'The member field must not exceed 255 characters.',
                'password.required' => 'A password is required.',
                'password.min' => 'The password must be at least 8 characters long.',
                'password.letters' => 'The password must contain at least one letter.',
                'password.symbols' => 'The password must contain at least one special character.',
            ];
        
            try {
                // Validate the request with the custom messages
                $data = $request->validate([
                    'name' => 'required|string|max:55',
                    'email' => 'required|email|unique:users,email,' . $user->id, 
                    'company_name' => 'required|string|max:255', 
                    'member' => 'required|max:255|string', 
                    'password' => [
                        'required',
                        Password::min(8)
                            ->letters()
                            ->symbols(),
                    ],
                ], $messages);
        
                // Update user data
                // $data = $request->validated();
                if (isset($data['password'])) {
                    $data['password'] = bcrypt($data['password']);
                }
                $user->update($data);
                return new UserResource($user);

            } catch (ValidationException $e) {
                // Capture the first error message
                $firstErrorMessage = collect($e->errors())->flatten()->first();
        
                return response()->json([
                    'message' => $firstErrorMessage,
                    'errors' => $e->errors(),
                ], 422);
            } 
    }


    public function destroy(User $user)
    {

        $user->delete();



        return response()->json(['message'=>'Employee Deleted Successfully!'],204);

    }


public function assignCourse($userId, $courseId)
{
    $admin = Auth::user();
    $user = User::find($userId);
    $course = NewCourse::find($courseId);
    $user_email = $user->email;



    if (!$admin || !$user || !$course) {
        $message = [];
        if (!$admin) {
            $message[] = 'Admin not found';
        }
        if (!$user) {
            $message[] = 'User not found';
        }
        if (!$course) {
            $message[] = 'Course not found';
        }

        return response()->json(['message' => $message], 404);
    }

    if ($admin->role !== 1 && $admin->role !== 2) {
        return response()->json(['message' => 'Unauthorized. Only admins can assign courses.'], 403);
    }

    if ($user->role === 1 || $user->role === 2) {
        return response()->json(['message' => 'Cannot assign courses to admin employee.'], 400);
    }

    if ($user->courses->contains($course->id)) {
        return response()->json(['message' => 'Course already assigned to the employee'], 400);
    }

    // Begin a transaction
    DB::beginTransaction();

    try {
        // Attach the course to the user
        $user->courses()->attach($course, ['admin_id' => $admin->id, 'status' => 'Not Started']);

        // Attach modules, lessons, and quizzes to the user
        foreach ($course->modules as $module) {
            $user->modules()->attach($module, ['status' => 'Not Started']);

            foreach ($module->lessons as $lesson) {
                $user->lessons()->attach($lesson, ['status' => 'Not Started']);

                foreach ($lesson->quizzes as $quiz) {
                    \DB::table('quiz_attempts') ->where('quiz_id', $quiz->id) ->where('user_id', $user->id) ->update(['attempt_count' => 0]);
                    $user->quizzes()->attach($quiz, ['status' => 'Not Started']);
                }
            }
        }

        // Commit the transaction if everything succeeds
        DB::commit();

        Mail::to($user_email)->send(new CourseAssigningMail($admin,$user,$course));

        return response()->json(['message' => 'Course assigned successfully'], 200);
    } catch (\Exception $e) {
        // Rollback the transaction if an error occurs
        DB::rollback();

        // Log the exception for debugging
        \Log::error('Failed to assign course: ' . $e->getMessage());

        return response()->json(['message' => 'Failed to assign course'], 500);
    }
}


   public function getAssignCourses($userId)
    {
       
        $user = User::find($userId);
        
        if (!$user) {
            
            return response()->json(['error' => 'User not found'], 404);
        }

        // $attempt = DB::table('quiz_attempts')
        //     ->where('user_id', $user->id)
        //     ->where('quiz_id', $quizId)
        //     ->first();

        // dd($attempt);

       
        $assignedCourses = $user->courses;

        $user = auth()->user();
        $assignedCourses = $user->courses;

        $courseIds = $assignedCourses->pluck('id');
        $courseid = $courseIds[0];
        // echo $courseid;
        // die();


        $assignedCoursesCount = $assignedCourses->count();
        return response()->json(['data' => ['user' => $user, 'assignedCourses' => $assignedCourses,'assignedCoursesCount' => $assignedCoursesCount, 'retake_count' => '3']]);
    }

   public function getAssignTasks()
    {
       $user = Auth::user();

        if (!$user) {
            
            return response()->json(['error' => 'User not found'], 404);
        }

        $assignedTasks = $user->tasks;

        $assignedTasksCount = $assignedTasks->count();
        return response()->json(['data' => ['user' => $user, 'assignedTasks' => $assignedTasks,'assignedTaskCount' => $assignedTasksCount]]);
    }

    public function getAssignedCoursesCount($userId)
    {
        
        $user = User::find($userId);

        
        if (!$user) {
          
            return response()->json(['error' => 'User not found'], 404);
        }

     
        $assignedCoursesCount = $user->courses()->count();

        
        return response()->json(['assignedCoursesCount' => $assignedCoursesCount]);
    }

    public function updateProfilePic(Request $request)
{
    try {
        $request->validate([
            'file' => 'required|image|mimes:jpg,png,jpeg|max:2048',
        ]);

        $user = Auth::user(); 

        if ($user->profile_pic) {
            Storage::disk('public')->delete($user->profile_pic);
        }

        $file = $request->file('file');
        $fileName = time() . '_' . $file->getClientOriginalName();

       $file->move(public_path('uploads'), $fileName);

        $user->update(['profile_pic' => 'uploads/' . $fileName]);

        return response()->json(['message' => 'Profile picture updated successfully', 'user' => $user]);
    } catch (\Exception $e) {
        \Log::error('Error updating profile picture: ' . $e->getMessage());
        return response()->json(['message' => 'An error occurred while updating the profile picture. Please try again.'], 500);
    }
}

        public function getProfilePic()
    {
        $user = Auth::user(); 

        if (!$user) {
            return response()->json(['error' => 'User not found'], 404);
        }

       
        return response()->json(['profile_pic' => $user->profile_pic]);
    }

    public function getUsersWithAssignedCourses()
    { 
        $currentAdmin = Auth::user();

        if (!$currentAdmin || $currentAdmin->role != 1 && $currentAdmin->role !=2) {
            return response()->json(['error' => 'Unauthenticated or unauthorized user'], 401);
        }

        $assignedId = AdminHelper::getAssignedId();
        
        // Determine the admin ID based on the value of assignedId
        $adminId = ($assignedId === "null") ? $currentAdmin->id : $assignedId;

        // $usersWithAssignedCourses = User::where('admin_id', $adminId)
        //     ->where('role', 0) 
        //     ->whereHas('courses')
        //     ->with(['courses' => function ($query) {
    
        //         $query->where('admin_id', $adminId);
        //     }])
        //     ->get();

            $usersWithAssignedCourses = User::where('admin_id', $adminId)
            ->where('role', 0)
            ->whereHas('courses')
            ->with(['courses' => function ($query) use ($adminId) {
                $query->where('admin_id', $adminId);
            }])
            ->get();

            // $admin = Auth::user();
            // $accountadmins = $admin->accountadmins()->distinct()->pluck('account_ids')->toArray();
           
            $accountadmins = [$adminId];
          //print_r($accountadmins);  die;
            if ($accountadmins) {
                foreach ($accountadmins as $accountadmin) {
                    $adminAccount = User::find($accountadmin);
                    if ($adminAccount) {
                        $usersWithAssignedCourses = $usersWithAssignedCourses->merge(
                            User::where('admin_id', $adminAccount->id)
                                ->where('role', 0)
                                ->whereHas('courses')
                                ->with(['courses' => function ($query) use ($adminAccount) {
                                    $query->where('admin_id', $adminAccount->id);
                                }])
                                ->get()
                        );
                    }
                }
            }


        if ($usersWithAssignedCourses->isEmpty()) {
            return response()->json(['message' => 'No users with assigned courses found for the current admin']);
        }

        $userData = [];

        foreach ($usersWithAssignedCourses as $user) {
            $assignedCourses = $user->courses;

            foreach ($assignedCourses as $course) {
                $assignmentDate = Carbon::parse($course->pivot->created_at)->format('m/d/Y H:i:s');
                $status = $course->pivot->status;

                $userData[] = [
                    'user_id' => $user->id,
                    'username' => $user->name,
                    'email' => $user->email,
                    'course_id' => $course->id,
                    'course_name' => $course->course_title,
                    'assignment_date' => $assignmentDate,
                    'status' => $status,
                ];
            }
        }

        return response()->json(['userData' => $userData]);
    }

    public function getUsersWithAssignedTasks()
    {
        $currentUser = Auth::user();

        if (!$currentUser || ($currentUser->role != 1 && $currentUser->role != 2)) {
            return response()->json(['error' => 'Unauthenticated or unauthorized user'], 401);
        }

        $assignedId = AdminHelper::getAssignedId();
            
        // Determine the admin ID based on the value of assignedId
        $adminId = ($assignedId === "null") ? $currentUser->id : $assignedId;
        // print_r($adminId);  die;
        
         $usersWithAssignedTasks = User::where('admin_id', $adminId)
            ->where('role', 0) 
            ->whereHas('tasks') 
            ->with(['tasks' => function ($query) use ($adminId) {
                $query->where('tasks.admin_id', $adminId);
            }])
            ->get();
        
         // print_r($usersWithAssignedTasks);  die;
         $accountadmins = [$adminId];

         // $admin = Auth::user();
         // $accountadmins = $admin->accountadmins()->distinct()->pluck('account_ids')->toArray();
        if($accountadmins){
            foreach ($accountadmins as $accountadmin){
                $adminAccount = User::find($accountadmin);
                if($adminAccount){
                $usersWithAssignedTasks = $usersWithAssignedTasks->merge(User::where('admin_id', $adminAccount->id) ->where('role', 0) ->whereHas('tasks') ->with(['tasks' => function ($query) use ($adminAccount) {
                    $query->where('tasks.admin_id', $adminAccount->id); }]) ->get());
                }
            }
        }


        if ($usersWithAssignedTasks->isEmpty()) {
            return response()->json(['message' => 'No users with assigned tasks found for the current admin']);
        }

        $userData = [];

        foreach ($usersWithAssignedTasks as $user) {
            $assignedTasks = $user->tasks;

            foreach ($assignedTasks as $task) {
                $assignmentDate = Carbon::parse($task->pivot->created_at)->format('m/d/Y H:i:s');
                $status = $task->pivot->status;

                // Construct user data array
                $userData[] = [
                    'user_id' => $user->id,
                    'username' => $user->name,
                    'email' => $user->email,
                    'task_id' => $task->id,
                    'task_name' => $task->task_name,
                    'assignment_date' => $assignmentDate,
                    'status' => $status,
                ];
            }
        }

        return response()->json(['userData' => $userData]);
    }

    public function updateAdmin(Request $request, $id)
    {
        try {
            $authenticatedUser = Auth::user();

            if (!$authenticatedUser || $authenticatedUser->role !== 2) {
                return response()->json(['error' => 'Unauthorized'], 401);
            }

            $admin = User::find($id);

            if (!$admin) {
                return response()->json(['error' => 'Admin not found'], 404);
            }

            try {
                $data = $request->validate([
                    'name' => 'required|string',
                    'email' => 'required|email|unique:users,email,' . $admin->id,
                    'password' => 'sometimes|required|string|min:6',
                    'company_name'=>'required|string',
                ], [
                    'name.required' => 'The name field is required.',
                    'email.required' => 'The email field is required.',
                    'email.email' => 'Please enter a valid email address.',
                    'email.unique' => 'This email is already taken.',
                    'password.required' => 'The password field is required.',
                    'password.min' => 'The password must be at least 6 characters.',
                    'company_name'=>'company name required',
                ]);

                $data['password'] = isset($data['password']) ? bcrypt($data['password']) : $admin->password;

                $admin->update($data);

                $response = [
                    'Admin' => $admin,
                    'message' => 'Admin updated successfully',
                ];

                return response()->json($response, 200);
            } catch (\Illuminate\Validation\ValidationException $e) {

                $firstErrorMessage = collect($e->validator->errors())->flatten()->first();
                return response()->json([
                    'message' => $firstErrorMessage,
                    'errors' => $e->validator->errors(),
                ], 422);

                //return response()->json(['message' => $e->validator->errors()], 422);
            }
        } catch (\Exception $e) {
            \Log::error('Error updating admin: ' . $e->getMessage() . PHP_EOL . $e->getTraceAsString());
            return response()->json(['error' => 'Internal Server Error'], 500);
        }
    }


public function deleteAdmin($id)
{
    try {
        $authenticatedUser = Auth::user();

        if (!$authenticatedUser || $authenticatedUser->role !== 2) {
            return response()->json(['error' => 'Unauthorized'], 401);
        }

        $admin = User::find($id);

        if (!$admin) {
            return response()->json(['error' => 'Admin not found'], 404);
        }
        $adminsAccounts =AccountAdmin::where('account_ids', $admin->id)->delete();

        $admin->delete();

        $response = [
            'message' => 'Admin deleted successfully',
        ];

        return response()->json($response, 200);
    } catch (\Exception $e) {
        \Log::error('Error deleting admin: ' . $e->getMessage());
        return response()->json(['error' => 'Internal Server Error'], 500);
    }
}

    public function uploadLogo(Request $request)
    {
        $request->validate([
            'logo' => 'required|image|mimes:jpg,png,jpeg|max:5120', 
        ]);

        $user = Auth::user();
        $logoFile = $request->file('logo');


        $userLogo = $user->logo;

        if (!$userLogo) {

            $logoFileName = $logoFile->getClientOriginalName();
            $logoPath = 'uploads/logos/' . $logoFileName;

            $userLogo = $user->logo()->create(['logo_path' => $logoPath]);


            if (!File::exists(public_path('uploads/logos/' . $logoFileName))) {
                $logoFile->move(public_path('uploads/logos'), $logoFileName);
            }
        } else {

            $newLogoPath = 'uploads/logos/' . $logoFile->hashName();

            if ($userLogo->logo_path !== $newLogoPath) {
                $logoFileName = $logoFile->getClientOriginalName();
                $logoPath = 'uploads/logos/' . $logoFileName;

                $userLogo->update(['logo_path' => $logoPath]);

                if (!File::exists(public_path('uploads/logos/' . $logoFileName))) {
                    $logoFile->move(public_path('uploads/logos'), $logoFileName);
                }
            }
        }
    
    if ($user->role === 1 || $user->role === 2) {
        $associatedUsers = $user->associatedUsers;
        foreach ($associatedUsers as $associatedUser) {
            $associatedUser->logo()->update(['logo_path' => $logoPath]);
        }
    }
        return response()->json([
            'message' => 'Logo uploaded successfully',
            'logo' => $userLogo,
        ]);
    }

    public function getLogo()
    {
        $user = Auth::user();
        $logo = $user->logo;

        if ($logo) {
            return response()->json(['logo' => $logo]);
        } 
        else {
            return response()->json(['message' => 'Logo not found']);
        }
    }

    public function fetchAdminData($adminId)
    {
        $admin = User::find($adminId);

        if ($admin) {

            $adminData = [
                'admin_id' => $admin->id,
                'name' => $admin->name,
                'email' => $admin->email,
                'company' => $admin->company_name,
                'employee_count' => $admin->employees()->count(),
                'course_count' => $admin->createdCourses()->count(),
                'task_count' => $admin->createdTasks()->count(),
                'quiz_count' => $admin->quizzes()->count(),
            ];

            $courseModuleCounts = 0;
            $moduleLessonCounts = 0;

            $courses = $admin->createdCourses()->with('modules.lessons')->get();

            foreach ($courses as $course) {

                $courseModuleCounts += $course->modules->count();

                foreach ($course->modules as $module) {
                    $moduleLessonCounts += $module->lessons->count();
                }
            }

            $adminData['module_count'] = $courseModuleCounts;
            $adminData['lesson_count'] = $moduleLessonCounts;

            return response()->json(['admin_data' => $adminData], 200);
        } else {

            return response()->json(['error' => 'Admin not found'], 404);
        }
    }
    /** San Code */
    public function getEmployeeProgress($id)
{
    $currentUser = Auth::user();

    if (!$currentUser || !in_array($currentUser->role, [1, 2])) {
        return response()->json(['error' => 'Unauthenticated or unauthorized user'], 401);
    }

    try {
        $employeeId = $id; 

        $employee = User::select('id', 'name', 'email', 'role', 'company_name')
                        ->where('id', $employeeId)
                        ->first();

        if (!$employee) {
            return response()->json(['message' => 'Employee not found'], 404);
        }

        $notStartedTaskCount = DB::table('task_users')
                                ->where('user_id', $employeeId)
                                ->where('status', 'Not Started')
                                ->count();

        $completedTaskCount = DB::table('task_users')
                                ->where('user_id', $employeeId)
                                ->where('status', 'Completed')
                                ->count();

        $pendingTaskCount = DB::table('task_users')
                                ->where('user_id', $employeeId)
                                ->where('status', 'In Progress')
                                ->count();

        $tasks = DB::table('task_users')
                    ->select('id', 'task_id', 'user_id', 'admin_id', 'status', 'created_at', 'updated_at')
                    ->where('user_id', $employeeId)
                    ->get();

        $taskCount = count($tasks);

        $taskIds = $tasks->pluck('task_id')->toArray();

        $taskNames = DB::table('tasks')
                        ->select('id', 'task_name', 'description', 'status', 'created_at', 'updated_at', 'admin_id')
                        ->whereIn('id', $taskIds)
                        ->get();

        $taskNamesMap = [];
        foreach ($taskNames as $task) {
            $taskNamesMap[$task->id] = [
                'task_name' => $task->task_name,
                'description' => $task->description,
                'status' => $task->status,
                'created_at' => $task->created_at,
                'updated_at' => $task->updated_at,
                'admin_id' => $task->admin_id,
            ];
        }

        $tasksData = $tasks->map(function ($task) use ($taskNamesMap) {
            return [
                'task_id' => $task->task_id,
                'task_name' => isset($taskNamesMap[$task->task_id]) ? $taskNamesMap[$task->task_id]['task_name'] : null,
                'description' => isset($taskNamesMap[$task->task_id]) ? $taskNamesMap[$task->task_id]['description'] : null,
                'status' => $task->status,
                'created_at' => Carbon::parse($task->created_at)->format('m/d/Y H:i:s'),
                'updated_at' => Carbon::parse($task->updated_at)->format('m/d/Y H:i:s'),
            ];
        });

        $courses = DB::table('new_course_users')
                        ->select('id', 'user_id', 'course_id', 'admin_id', 'status', 'created_at', 'updated_at')
                        ->where('user_id', $employeeId)
                        ->get();

        $courseCount = $courses->count();

        $notStartedCourseCount = $courses->where('status', 'Not Started')->count();
        $completedCourseCount = $courses->where('status', 'Completed')->count();
        $pendingCourseCount = $courses->where('status', 'In Progress')->count();

        $courseIds = $courses->pluck('course_id')->toArray();

        $courseTitles = DB::table('new_courses')
                            ->select('id', 'course_title', 'course_description', 'course_type', 'status', 'created_at', 'updated_at', 'user_id')
                            ->whereIn('id', $courseIds)
                            ->get();

        $courseTitlesMap = [];
        foreach ($courseTitles as $course) {
            $courseTitlesMap[$course->id] = [
                'course_title' => $course->course_title,
                'course_description' => $course->course_description,
                'course_type' => $course->course_type,
                'status' => $course->status,
                'created_at' => $course->created_at,
                'updated_at' => $course->updated_at,
                'user_id' => $course->user_id,
            ];
        }

        $employeeData = [
            'employee_id' => $employee->id,
            'employee_name' => $employee->name,
            'email' => $employee->email,
            'role' => $employee->role,
            'company_name' => $employee->company_name,
            'not_started_task_count' => $notStartedTaskCount,
            'completed_task_count' => $completedTaskCount,
            'pending_task_count' => $pendingTaskCount,
            'tasks' => $taskCount,
            'course_count' => $courseCount,
            'not_started_course_count' => $notStartedCourseCount,
            'completed_course_count' => $completedCourseCount,
            'pending_course_count' => $pendingCourseCount,
            'courses' => $courses->map(function ($course) use ($courseTitlesMap) {
                return [
                    'course_id' => $course->course_id,
                    'course_title' => isset($courseTitlesMap[$course->course_id]) ? $courseTitlesMap[$course->course_id]['course_title'] : null,
                    'course_description' => isset($courseTitlesMap[$course->course_id]) ? $courseTitlesMap[$course->course_id]['course_description'] : null,
                    'course_type' => isset($courseTitlesMap[$course->course_id]) ? $courseTitlesMap[$course->course_id]['course_type'] : null,
                    'status' => $course->status,
                    'created_at' => Carbon::parse($course->created_at)->format('m/d/Y H:i:s'),
                    'updated_at' => Carbon::parse($course->updated_at)->format('m/d/Y H:i:s'),
                    'user_id' => $course->user_id,
                ];
            }),
        ];
        $clickCount = DB::table('email_tracking')
                        ->where('user_id', $employeeId)
                        ->where('event_type', 'click')
                        ->count();

        $openCount = DB::table('email_tracking')
                        ->where('user_id', $employeeId)
                        ->where('event_type', 'open')
                        ->count();

        $employeeData['email_tracking_counts'] = [
            'click_count' => $clickCount,
            'open_count' => $openCount,
        ];

        $totalEmailCount = DB::table('email_tracking')
                            ->where('user_id', $employeeId)
                            ->count();

        $employeeData['email_tracking_total_count'] = $totalEmailCount;

        return response()->json(['employeeData' => $employeeData]);
    } catch (\Exception $e) {
        return response()->json(['error' => 'Failed to fetch employee progress', 'message' => $e->getMessage()], 500);
    }
}
/** San User list whos has not started the task  */
public function getUsersWithNotStartedCourses(Request $request)
{
    // Calculate 7 days ago from current date
    $sevenDaysAgo = Carbon::now()->subDays(7);
    $tasks = DB::table('task_users')
                ->where('status', 'Not Started')
                ->whereDate('created_at', '<=', $sevenDaysAgo->toDateString()) 
                ->select('id', 'task_id', 'user_id', 'admin_id', 'status', 'created_at', 'updated_at')
                ->get();
    
    $tasksData = [];

    
    foreach ($tasks as $task) {
        $email = DB::table('users')->where('id', $task->user_id)->value('email');
        $userId = $task->user_id;
        $adminId = $task->admin_id;
        $taskId = $task->task_id;

        $admin = User::find($adminId);
        $user = User::find($userId);
        $task = Task::find($taskId);


        $task_name = $task->task_name;
        $user_email = $user->email;
        $user_name = $user->name;

          Log::info('Task Information', [
            'task_id' => $taskId,
            'task_name' => $task_name,
            'user_id' => $userId,
            'user_name' => $user_name,
            'user_email' => $user_email,
            'admin_id' => $adminId,
            'status' => $task->status,
            'created_at' => $task->created_at,
            'updated_at' => $task->updated_at,
        ]);

        
        if ($email) {
            $tasksData[] = [
                'email' => $email,
                'created_at' => $task->created_at,
            ];

            try {
                // Attempt to send the email
                Mail::to($email)->send(new MailtoNotStartedUser($user_name, $task_name));
                
                // Log a message or perform an action if the email was sent successfully
                // Log::info("Email successfully sent to $email");
            } catch (Exception $e) {
                // Handle the exception if sending the email fails
                // For example, log the error message
                Log::error('Failed to send email', [
                    'email' => $email,
                    'error' => $e->getMessage(),
                ]);
                
                // Optionally, you can also handle the exception by notifying the user or taking other actions
                }
        }   }
    
    return response()->json(['message' => 'Mail sent successfully'], 200);
}

public function getUsersWithNotStartedTasks(Request $request){

    $sevenDaysAgo = Carbon::now()->subDays(7);
    $courses = DB::table('new_course_users')
                ->where('status', 'Not Started')
                ->whereDate('created_at', '<=', $sevenDaysAgo->toDateString()) 
                ->select('id', 'course_id', 'user_id', 'admin_id', 'status', 'created_at', 'updated_at')
                ->get();

    // dd($courses);
    
    $courseData = [];

    foreach ($courses as $course) {
        $email = DB::table('users')->where('id', $course->user_id)->value('email');
        $userId = $course->user_id;
        $adminId = $course->admin_id;
        $courseId = $course->course_id;

        $admin = User::find($adminId);
        $user = User::find($userId);
        $course = NewCourse::find($courseId);
        // dd($course);


        $course_name = $course->course_title;
        $user_email = $user->email;
        $user_name = $user->name;

          Log::info('course Information', [
            'course_id' => $courseId,
            'course_name' => $course_name,
            'user_id' => $userId,
            'user_name' => $user_name,
            'user_email' => $user_email,
            'admin_id' => $adminId,
            'status' => $course->status,
            'created_at' => $course->created_at,
            'updated_at' => $course->updated_at,
        ]);

        
        if ($email) {
            $courseData[] = [
                'email' => $email,
                'created_at' => $course->created_at,
            ];

            try {
                // Attempt to send the email
                Mail::to($email)->send(new MailtoNotStartedCourse($user_name, $course_name));
                
                // Log a message or perform an action if the email was sent successfully
                Log::info("Email successfully sent to $email");
            } catch (Exception $e) {
                // Handle the exception if sending the email fails
                // For example, log the error message
                Log::error('Failed to send email', [
                    'email' => $email,
                    'error' => $e->getMessage(),
                ]);
                
                // Optionally, you can also handle the exception by notifying the user or taking other actions
                }
        }   }

    return response()->json(['message' => 'Mail sent successfully'], 200);

}


public function showAdminList()
{
    $userId = Auth::user()->id;
    $admin = User::find($userId);

    // $userDetails = User::whereHas('accountAdmins', function ($query) use ($userId) {
    //     $query->where('user_id', $userId);
    // })->select('id', 'name')->get();

    $userDetails = DB::table('account_admin AS aa')
    ->join('users AS us', 'us.id', '=', 'aa.account_ids')
    ->where('aa.user_id', $userId)
    ->select('us.id', 'us.name')
    ->get();

    return response()->json(['Assignedadmins' => $userDetails]);
}


public function getCurrentUser($id)
    {
        $admin = User::find($id);

        if (!$admin) {
            return response()->json(['message' => 'User not found'], 404);
        }

        // Call the helper function
        $currentUser = AdminHelper::getAdminAccount($admin);

        return response()->json(['message' => 'User Details', 'user' => $admin]);
    }


public function test(){
    $admin = Auth::user();
    $adminId = $admin->id;
    if (!$admin) {
            return response()->json(['message' => 'User not found'], 404);
        }
    $assignedId = AdminHelper::getAssignedId();
    if($assignedId){
        $adminId = $assignedId ? $assignedId : $admin->id ;
    }
    return response()->json(['assignedAdminId' => $adminId]);
}


}

