<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class CheckCourseCompletion
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure(\Illuminate\Http\Request): (\Illuminate\Http\Response|\Illuminate\Http\RedirectResponse)  $next
     * @return \Illuminate\Http\Response|\Illuminate\Http\RedirectResponse
     */
    public function handle(Request $request, Closure $next)
    {
        $user = Auth::user();

        if ($user && $user->courses()->find($request->route('courseId'))->pivot->status === 'Completed') {
            // If the user has completed the course, restrict access
            return response()->json(['message' => 'Access denied. User has completed the course.'], 403);
        }

        // If the user has not completed the course, allow access
        return $next($request);
    }
}
