<?php

// QuizCompletionMiddleware.php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class CheckQuizCompletion
{
    /**
     * Handle an incoming request.
     *
     * @param \Illuminate\Http\Request $request
     * @param \Closure $next
     * @return mixed
     */
    public function handle(Request $request, Closure $next)
    {
        $user = Auth::user();

        // Replace 'quizId' with the actual route parameter name for quiz ID
        if ($user && $user->quizzes()->find($request->route('quizId'))->pivot->status === 'Completed') {
            // If the user has completed the quiz, restrict access
            return response()->json(['message' => 'Access denied. User has completed the quiz.'], 403);
        }

        // If the user has not completed the quiz, allow access
        return $next($request);
    }
}
