<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use App\Models\Quiz;

class CheckQuizCompletion
{
    public function handle(Request $request, Closure $next)
    {
        $user = Auth::user();

        // Use findOrFail to automatically handle the case when the quiz is not found
        $quiz = Quiz::findOrFail($request->route('quizId'));

        if ($user && $user->quizzes()->find($quiz->id)->pivot->status === 'Completed') {
            // If the user has completed the quiz, restrict access
            return response()->json(['message' => 'Access denied. User has completed the quiz.'], 403);
        }

        // If the user has not completed the quiz or there is no valid relationship, allow access
        return $next($request);
    }
}
