<?php



namespace App\Http\Requests;



use Illuminate\Foundation\Http\FormRequest;



class LoginRequest extends FormRequest

{

    /**

     * Determine if the user is authorized to make this request.

     *

     * @return bool

     */

    public function authorize()

    {

        return true;

    }



    /**

     * Get the validation rules that apply to the request.

     *

     * @return array<string, mixed>

     */

    public function rules()

    {

        return [

            'email' => 'required|email|string|exists:users,email',

            'password' => [

                'required',

            ],

            'remember' => 'boolean'

        ];

    }
    public function messages()
    {
        return [
            'email.required' => 'The email field is required.',
            'email.email' => 'The email must be a valid email address.',
            'email.exists' => 'The provided email does not exist.',
            'password.required' => 'The password field is required.',
            'remember.boolean' => 'The remember field must be true or false.',
        ];
    }
}

