<?php



namespace App\Http\Requests;



use Illuminate\Foundation\Http\FormRequest;

use Illuminate\Validation\Rules\Password;



class UpdateUserRequest extends FormRequest

{

    /**

     * Determine if the user is authorized to make this request.

     *

     * @return bool

     */

    public function authorize()

    {

        return true;

    }



    /**

     * Get the validation rules that apply to the request.

     *

     * @return array<string, mixed>

     */

    public function rules()

    {

        return [

            'name' => 'required|string|max:55',

            'email' => 'required|email|unique:users,email,'.$this->id,

            'company_name'=> 'string|max:255',

            'member' => 'max:255|string',

            'password' => [

                'confirmed',

                Password::min(8)

                    ->letters()

                    ->symbols(),

            ]

        ];

    }

}

