<?php
namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class AdminMarksMail extends Mailable
{
    use Queueable, SerializesModels;

    public $user;
    public $feedback;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($user,$correctanswer, $totalquestion, $percentage, $attempt_no, $quizName)
    {
        $this->user = $user;

        $this->correctanswer = $correctanswer;

        $this->totalquestion = $totalquestion;

        $this->percentage = $percentage;

        $this->attempt_no = $attempt_no;

        $this->quizName = $quizName;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->view('emails.admin_marks')
                    ->with([
                        'userName' => $this->user->name,
                        'correctanswer' => $this->correctanswer,
                        'totalquestion' => $this->totalquestion,
                        'percentage' => $this->percentage,
                        'attempt_no' => $this->attempt_no,
                        'quizName' => $this->quizName,
                    ]);
    }
}


?>