<?php
namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class CourseReassigningMail extends Mailable
{
    use Queueable, SerializesModels;

    public $user;
    public $admin;
    public $course;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($admin,$user,$course)
    {

        $this->admin = $admin;

        $this->user = $user;

        $this->course = $course;


    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->view('emails.reassigning_admin')
                    ->with([
                        'employeename' => $this->user->name,
                        'coursename' => $this->course->course_title,
                        'adminname' => $this->admin->name,
                    ]);
    }
}


?>