<?php
namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class MailtoNotStartedCourse extends Mailable
{
    use Queueable, SerializesModels;

    public $user_name;
    public $course_name;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($user_name, $course_name)
    {

        $this->user_name = $user_name;

        $this->course_name = $course_name;

    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->view('emails.mailTonotStartedCourse')
                    ->with([
                        'user_name' => $this->user_name,
                        'coursename' => $this->course_name,
                    ]);
    }
}


?>