<?php
namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class MailtoNotStartedUser extends Mailable
{
    use Queueable, SerializesModels;

    public $user_name;
    public $task_name;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($user_name, $task_name)
    {

        $this->user_name = $user_name;

        $this->task_name = $task_name;

    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->view('emails.mailTonotStartedUsers')
                    ->with([
                        'user_name' => $this->user_name,
                        'taskname' => $this->task_name,
                    ]);
    }
}


?>