<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class TaskCompleteMail extends Mailable
{
    use Queueable, SerializesModels;

    public $user;
    public $admin;
    public $task;

    /**
     * Create a new message instance.
     *
     * @param $admin
     * @param $user
     * @param $task
     * @return void
     */
    public function __construct($admin, $user, $task)
    {
        // Ensure these are not collections
        $this->admin = $admin instanceof \Illuminate\Database\Eloquent\Collection ? $admin->first() : $admin;
        $this->user = $user instanceof \Illuminate\Database\Eloquent\Collection ? $user->first() : $user;
        $this->task = $task instanceof \Illuminate\Database\Eloquent\Collection ? $task->first() : $task;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->view('emails.task_completed')
                    ->with([
                        'employeename' => $this->user->name,
                        'taskname' => $this->task->task_name,
                        'adminname' => $this->admin->name,
                    ]);
    }
}
