<?php
namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class TaskStartMail extends Mailable
{
    use Queueable, SerializesModels;

    public $user;
    public $admin;
    public $taskDetails;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($admin,$user,$taskDetails)
    {

        $this->admin = $admin;

        $this->user = $user;

        $this->taskDetails = $taskDetails;


    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->subject('New Task Assign')
                    ->view('emails.task_assigning')
                    ->with([
                        'employeename' => $this->user->name,
                        'taskname' => $this->taskDetails->task_name,
                        'adminname' => $this->admin->name,
                    ]);
    }
}


?>