<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Quiz extends Model
{
    use HasFactory;
    protected $fillable = ['title' , 'lesson_id'];

    public function questions()
    {
        return $this->hasMany(Question::class);
    }
        public function lesson()
    {
        return $this->belongsTo(Lesson::class);
    }

        public function users()
    {
        return $this->belongsToMany(User::class, 'new_quiz_users', 'quiz_id', 'user_id')->withPivot('status')->withTimestamps();
    }
}
