<?php



namespace App\Models;



// use Illuminate\Contracts\Auth\MustVerifyEmail;

use Illuminate\Database\Eloquent\Factories\HasFactory;

use Illuminate\Foundation\Auth\User as Authenticatable;

use Illuminate\Notifications\Notifiable;

use Laravel\Sanctum\HasApiTokens;

use App\Models\NewCourse;
use App\Models\Module;
use App\Models\Lesson;
use App\Models\TemplateCategory;
use App\Models\LandingPageCategory;
class User extends Authenticatable

{

    use HasApiTokens, HasFactory, Notifiable;

    /**

     * The attributes that are mass assignable.

     *

     * @var array<int, string>

     */

    protected $fillable = [

        'name',

        'email',

        'google_secret_key',

        'user_type',
        
        'password',

        'role',
        
        'mfa',

        'profile_pic',

        'admin_id',
        
        'company_name',

        'member',

    ];

    /**

     * The attributes that should be hidden for serialization.

     *

     * @var array<int, string>

     */

    protected $hidden = [

        'password',

        'remember_token',

    ];



    /**

     * The attributes that should be cast.

     *

     * @var array<string, string>

     */

    protected $casts = [

        'email_verified_at' => 'datetime',
        'mfa' => 'boolean',

    ];


    public function createdCourses()
    {
        return $this->hasMany(NewCourse::class, 'user_id');
    }


    public function createdTasks()
    {
        return $this->hasMany(Task::class, 'admin_id');
    }
    
        public function createdTemplateCategory()
    {
        return $this->hasMany(TemplateCategory::class, 'admin_id');
    }

        public function createdLandingPageCategory()
    {
        return $this->hasMany(LandingPageCategory::class, 'admin_id');
    }
    public function courses()

    {

        return $this->belongsToMany(NewCourse::class, 'new_course_users', 'user_id', 'course_id')->withPivot('status')->withTimestamps();

    }

    public function modules()

    {

        return $this->belongsToMany(Module::class, 'module_users', 'user_id', 'module_id')->withPivot('status')->withTimestamps();

    }


    public function lessons()

    {

        return $this->belongsToMany(Lesson::class, 'lesson_users', 'user_id', 'lesson_id')->withPivot('status')->withTimestamps();

    }

    public function tasks()
    {
        return $this->belongsToMany(Task::class, 'task_users', 'user_id', 'task_id')->withPivot('status')->withTimestamps();
    }

    public function quizzes()
    {
        return $this->belongsToMany(Quiz::class, 'new_quiz_users', 'user_id', 'quiz_id')->withPivot('status')->withTimestamps();
    }
    public function responses()
    {
        return $this->hasMany(Response::class);
    }

        public function logo()
    {
        return $this->hasOne(Logo::class);
    }
        public function landingPages()
    {
        return $this->hasMany(LandingPage::class, 'admin_id');
    }

        public function employees()
    {
        return $this->hasMany(User::class, 'admin_id');
    }

        public function associatedUsers()
    {
        
        return $this->hasMany(User::class, 'admin_id');
    }
    public function accountadmins()
    {
        return $this->hasMany(AccountAdmin::class);
    }

}

