<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Module extends Model
{
    protected $table = 'module';
    use HasFactory;
    protected $fillable = ['title',  'course_id', 'order'];

    public function course()
    {
        return $this->belongsTo(NewCourse::class);
    }

    public function lessons()
    {
        return $this->hasMany(Lesson::class, 'module_id');
    }


    public function coursewithmodule()
    {
        return $this->belongsTo(NewCourse::class, 'course_id');
    }
}
