<?php



use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\DB;


/*

|--------------------------------------------------------------------------

| Web Routes

|--------------------------------------------------------------------------

|

| Here is where you can register web routes for your application. These

| routes are loaded by the RouteServiceProvider within a group which

| contains the "web" middleware group. Now create something great!

|

*/


Route::get('/test-database-connection', function () {
    try {
        $pdo = new PDO('mysql:host=' . env('DB_HOST') . ';dbname=' . env('DB_DATABASE'), env('DB_USERNAME'), env('DB_PASSWORD'));
        echo 'Connected successfully!';
    } catch (PDOException $e) {
        echo 'Connection failed: ' . $e->getMessage();
    }
});
Route::get('/', function () {

    return view('welcome');

});

Route::get('/api/v1/doc', function () {
    // Path to your JSON file
    $jsonFilePath = public_path('uploads/api_doc/LMS_Live.postman_collection.json');

    // Check if the file exists
    if (File::exists($jsonFilePath)) {
        // Read the JSON file contents
        $jsonContent = File::get($jsonFilePath);

        // Decode JSON content into an array
        $jsonData = json_decode($jsonContent, true);
            // dd($jsonContent);
        // Pass the JSON data to the view
        return view('api_doc', ['jsonData' => $jsonData]);
    } else {
        // File not found, return an error or handle it accordingly
        abort(404, 'JSON file not found');
    }
});