<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\PhishingSimulation;
use App\Mail\PhishingSimulationMail;
use Illuminate\Support\Facades\Mail;
use App\Models\User;

class PhishingSimulationController extends Controller
{
    public function createPhishingSimulation(Request $request)
    {
        $data = $request->validate([
            'subject' => 'required|string',
            'body' => 'required|string',
            'malicious_links' => 'nullable|string',
        ]);

        $simulation = PhishingSimulation::create($data);

        // Code to send emails goes here

        return response()->json(['message' => 'Phishing simulation created successfully']);
    }

    public function sendPhishingEmails()
    {
\Log::info("log start");
        $users = User::all();
\Log::info("All Users". $users);
        foreach ($users as $user) {

          $mailing =   Mail::to($user->email)->send(new PhishingSimulationMail([
                'userName' => $user->name,
                'verificationLink' => 'https://fake-phishing-site.com/verify/' . $user->verification_token,
            ]));

           \Log::info("log end" . $mailing);
        }

        return response()->json(['message' => 'Phishing emails sent successfully']);
    }
}
